=== debian/changelog ===
ros-indigo-ocl (2.8.4-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Orocos Developers <orocos-dev@lists.mech.kuleuven.be>  Sat, 26 Nov 2016 12:52:34 -0000
